   10 REM U2ARY_TM.BAS
   20 REM UOSAT Telemetry.  Conversion of Solar Array data to WOD format
   30 
   40 REM Written by C.Wallis G3CWV
   50 REM Created 23-Nov-2004
   51 REM Version V 1.0  23-Nov-2004
      
   60 REM Based on U2MAG_TM.BAS  Version V 1.1 27-Nov-2002
   70 REM Intrepeter/compiler BBC BASIC for Windows
   80 REM Based on U2TM9 V 1.4 18-APR-97
   90 ON ERROR GOSUB 2710
  100 last_ptr = 0
  110 frame_no = 0
  120 b1 = 0
  130 b2 = 0
  140 b3 = 0
  150 
  160 REPEAT
  170   PRINT
  180   PRINT "Enter TELEMETRY DATA file name "
  190   INPUT"or press return for default file TEMP.DAT  "reply$
  200   IF reply$ ="" THEN in_file_name$="TEMP.DAT" ELSE in_file_name$=reply$
  210   f1 = OPENIN(in_file_name$)
  220   IF f1<1 THEN PRINT:PRINT"File not found!"
  230 UNTIL f1>0
  240 REM Input file now open
  250 REM GOTO 220
  260 
  270 REPEAT
  280   PRINT "Enter Output file name "
  290   INPUT"or press return for default file TEMP.OUT  "reply$
  300   IF reply$ ="" THEN out_file_name$="temp.out" ELSE out_file_name$=reply$
  310   f2 = OPENOUT(out_file_name$)
  320   IF f2<1 THEN PRINT:PRINT"Unable to open output file"
  330 UNTIL f2>0
  340 REM Output file now open
  350 first% = TRUE
  360 analogue% = TRUE
  370 file_length%= EXT#f1 :REM Get file size file_length%
  380 file_ptr%=0 : REM Set file pointer to start of file
  390 DIM c%(6)  :REM Array of characters
  400 ON ERROR GOSUB 2710
  410 REPEAT: REM Find first good frame
  420   
  430   REPEAT
  440     PROCget_uosat2
  450     file_ptr%=PTR#f1 :REM Store pointer to after UoSat id
  460     PRINT"Telemetry block found"
  470     PRINT "File pointer =  ";file_ptr%
  480     
  490     
  500     PROCdisplay_time
  510     INPUT "OK? Y/N  " reply$
  520     
  530   UNTIL ((reply$="Y")OR(reply$="y"))
  540   PTR#f1 = file_ptr%  :REM Restore file to end of UoSAT id
  550   PROCget_time
  560   
  570   PROCget_arr
  580   PROCsave
  590   first% = FALSE
  600   REM ********* Main Loop ********
  610   last_ptr=PTR#f1
  620   REPEAT
  630     PROCget_uosat2
  640     file_ptr%=PTR#f1  : REM points to space after UOSAT-2 ... Doesnt work without it
  650     PROCget_time
  660     PROCget_arr
  670     PROCsave
  680   UNTIL PTR#f1>file_length%-300
  690   REM **** End of MAIN LOOP ****
  700   CLOSE#0
  710   *bye      :REM Return to MS-DOS
  720   
  730   REM ---------
  740   DEF FNgetb
  750   REM Reads a byte from input file.
  760   REM Returns byte
  770   REM If EOF, closes files and ends program
  780   byte = BGET#f1
  790   last_ptr = PTR#f1
  800   IF  EOF#f1  THEN
  810     PRINT "  End of Input File at  ";PTR#f1
  820     CLOSE#0
  830     END
  840   ENDIF
  850   = byte
  860   REM --------------------
  870   DEF PROCget_time
  880   REM Reads data from input file and calculates frame number
  890   REM starting at 1
  900   REM Frame numbering is based on time separation
  910   REM between frames of 4.82 secs
  920   REM Output ... frame_no$
  930   
  940   REPEAT
  950   UNTIL CHR$(FNgetb) <> " " : REM find start of date
  960   PTR#f1=PTR#f1+6 :REM Skip date
  970   hr_ms = FNgetb -48: hr_ls  = FNgetb -48: REM Get time
  980   mm_ms = FNgetb-48 :mm_ls = FNgetb-48
  990   sec_ms = FNgetb-48 : sec_ls = FNgetb-48
 1000   tm_time = hr_ms*36000 + hr_ls*3600 + mm_ms*600 +mm_ls*60 +sec_ms*10 +sec_ls
 1010   IF first% THEN
 1020     tm_time0 = tm_time
 1030     frame_no = 1
 1040     first% = FALSE
 1050   ELSE
 1060     REM  PRINT hr_ms, hr_ls, mm_ms, mm_ls, sec_ms, sec_ls
 1070     REM  PRINT PTR#f1
 1080     frame_no =FNrn((tm_time-tm_time0)/4.82) +1
 1090   ENDIF
 1100   REM Convert to three digit ASCII string
 1110   REM PRINT tm_time, frame_no
 1120   frame_no$ =FNthree_digits(frame_no)
 1130   ENDPROC
 1140   REM --------------------------------
 1150   DEF PROCget_arr
 1160   REM Gets TM data for channels 0, 10, 20, 30
 1170   REM Outputs arr1, arr2, arr2
 1180   PROCget_tm(0)
 1190   IF checksum%=0 THEN arr1=n% ELSE arr1=0
 1200   PROCget_tm(10)
 1210   IF checksum%=0  THEN arr2=n% ELSE arr2=0
 1220   PROCget_tm(20)
 1230   IF checksum%=0 THEN arr3=n% ELSE arr3=0
 1231   PROCget_tm(30)
 1232   IF checksum%=0 THEN arr4=n% ELSE arr4=0
        
 1240   ENDPROC
 1250   
 1260   REM -------------------------
 1270   
 1280   DEF PROCsave
 1290   REM Builds up output string as output$
 1300   REM Outputs to file one character at a time
 1310   arr1$ = FNthree_digits(arr1)
 1320   arr2$ = FNthree_digits(arr2)
 1330   arr3$ = FNthree_digits(arr3)
        arr4$ = FNthree_digits(arr4)
 1340   output$ = "0"+frame_no$ +" "+ arr1$ + " " + arr2$ + " " + arr3$ + " " + arr4$
 1350   FOR I = 1 TO LEN(output$)
 1360     BPUT#f2, ASC(MID$(output$,I,1))
 1370   NEXT I
 1380   BPUT#f2 ,13
 1390   BPUT#f2, 10
 1400   ENDPROC
 1410   REM -----------------------------
 1420   
 1430   DEF FNthree_digits(number)
 1440   
 1450   REM Converts three integer to three digit ASCII string
 1460   
 1470   IF ((number>999)OR(number < 0)) THEN
 1480     string$ ="000"
 1490   ELSE
 1500     string$=STR$(number)
 1510     FOR I = 1 TO 2
 1520       IF LEN(string$) <3 THEN string$ = "0"+string$
 1530     NEXT I
 1540   ENDIF
 1550   = string$ : Return Output string
 1560   
 1570   
 1580   REM ------------------------------
 1590   
 1600   DEF FNrn(X) = INT(X+0.5)
 1610   REM Function to round real to nearest integer
 1620   REM ---------------------------
 1630   
 1640   DEF PROCget_uosat2
 1650   REM Scan file looking for sequence of characters "UOSAT-2".  When found sets uosat% TRUE.  Terminates just before end of file
 1660   uosat2%=FALSE
 1670   REPEAT
 1680     
 1690     IF NOT (FNgetb=&55) THEN 1780: REM U
 1700     IF NOT (FNgetb=&4F) THEN 1780: REM O
 1710     IF NOT (FNgetb=&53) THEN 1780: REM S
 1720     IF NOT (FNgetb=&41) THEN 1780: REM A
 1730     IF NOT (FNgetb=&54) THEN 1780: REM T
 1740     IF NOT (FNgetb=&2D) THEN 1780: REM -
 1750     IF NOT (FNgetb)=&32) THEN 1780: REM 2
 1760     uosat2%=TRUE
 1770     
 1780     
 1790   UNTIL (PTR#f1 > (file_length%-200)) OR uosat2%
 1800   ENDPROC
 1810   REM -----------
 1820   DEF PROCget_tm(ch_no%)
 1830   LOCAL i%
 1840   ch_tens%=ch_no% DIV 10
 1850   ch_units%=ch_no% MOD 10
 1860   PTR#f1=file_ptr%
 1870   REPEAT
 1880     b1 = b2
 1890     b2 = b3
 1900     b3 = FNgetb
 1910   UNTIL ((b1=&D)AND(b2=&A)AND(b3=&A))OR EOF#f1
 1920   REM UNTIL ((FNgetb=&D)AND(FNgetb=&A)AND(FNgetb=&A))OR EOF#f1 :REM file now positioned on  CR LF LF before TM block
 1930   IF EOF#f1 THEN PRINT "EOF":CLOSE#0:END
 1940   PTR#f1=PTR#f1+ch_tens%*62+ch_units%*6
 1950   FOR i%=1 TO 6
 1960     c%(i%)=FNhex(FNgetb) : REM get all 6 digits of TM, and decode ASCII
 1970   NEXT i%
 1980   REM check channel no
 1990   REM IF NOT ((ch_tens%=c%(1)) AND (ch_units%=c%(2))) THEN PROCnormal_format:PRINT:PRINT "Channel No error.  Expected ";ch_no%;"  Read  ";c%(1)*10+c%(2):PROCrestore_format
 2000   IF NOT ((ch_tens%=c%(1)) AND (ch_units%=c%(2))) THEN PRINT "Channel error ... data out of sync at  ";PTR#f1
 2010   IF analogue%=TRUE THEN n%=c%(3)*100+c%(4)*10+c%(5) ELSE n%=c%(3)*&100+c%(4)*&10+c%(5)
 2020   REM now calculate checksum
 2030   checksum%=c%(1)
 2040   FOR i%= 2 TO 6
 2050     checksum%=checksum% EOR c%(i%)
 2060   NEXT i%
 2070   REM IF NOT (checksum%=0) THEN PROCnormal_format:PRINT:PRINT"Checksum error.  Channel  ";ch_no%:FOR i%=1 TO 6: PRINT; ~c%(i%)" ";:NEXT i%:PRINT: PROCrestore_format
 2080   IF NOT (checksum%=0) THEN PRINT"Checksum error at  ";PTR#f1
 2090   ENDPROC
 2100   REM----------
 2110   DEF FNhex(byte%)
 2120   REM Converts single ASCII chr to HEX. Assumes range &30 to &45
 2130   IF (byte% > &40) AND (byte% < &47) THEN temp%=byte%-&37 ELSE temp%=byte%-&30
 2140   =temp%
 2150   REM---------
 2160   REM Functions for converting telemetry data to real units
 2170   DEF FNtemp(n%)=(480-n%)/5
 2180   DEF FNarraycur(n%)=1.9*(516-n%)
 2190   REM ---------
 2200   DEF PROCnormal_format
 2210   REM Saves the current print format in format%, changes to default 10
 2220   format% = @%
 2230   @% = 10
 2240   ENDPROC
 2250   REM --------
 2260   DEF PROCrestore_format
 2270   REM Restores the format to value previously stored in format%
 2280   @% = format%
 2290   ENDPROC
 2300   REM -------
 2310   DEF FNyes
 2320   REM Input reply$
 2330   REM Returns -1 (TRUE) if reply is Y, otherwise 0 (FALSE)
 2340   IF ((reply$ = "Y") OR (reply$ = "y")) THEN = TRUE ELSE = FALSE
 2350   REM ------
 2360   DEF FNno
 2370   REM Input reply$
 2380   REM Returns -1 (TRUE) if reply is N, otherwise 0 (FALSE)
 2390   IF ((reply$ = "N") OR (reply$ = "n")) THEN = TRUE ELSE = FALSE
 2400   REM -------
 2410   DEF PROCdisplay_time
 2420   REPEAT  : REM Skip the spaces after UOSAT-2
 2430   UNTIL CHR$(FNgetb) <> " "
 2440   
 2450   PTR#f1 = PTR#f1 - 1 :REM Back one so that we can print the first character of date
 2460   PRINT
 2470   PRINT "Date  ";
 2480   PRINT CHR$(FNgetb);CHR$(FNgetb); :REM year
 2490   PRINT "-";CHR$(FNgetb);CHR$(FNgetb);: REM month
 2500   PRINT "-";CHR$(FNgetb);CHR$(FNgetb);: REM day
 2510   PTR#f1 = PTR#f1+1 :REM Skip day of week number
 2520   
 2530   
 2540   PRINT "   Time  ";CHR$(FNgetb);CHR$(FNgetb);":";CHR$(FNgetb);CHR$(FNgetb);":";CHR$(FNgetb);CHR$(FNgetb): REM time
 2550   ENDPROC
 2560   REM ------
 2570   DEF PROCreset_file
 2580   REM Allows user to change file pointer
 2590   PRINT:PRINT "Enter new file pointer in range 0 to ";file_length%;
 2600   INPUT"  ", ptr%
 2610   PTR#f1 = ptr%  :PRINT
 2620   ENDPROC
 2630   REM________
 2640   DEF PROCbar_wait
 2650   PRINT
 2660   PRINT "Press space bar to contiune"
 2670   IF GET
 2680   ENDPROC
 2690   REM---------
 2700   REM Deal with End of file and errors
 2710   IF (ERR<>254) PROCnormal_format:PRINT:REPORT:PRINT " at line ";ERL: CLOSE# 0: END : REM Error terminate program
 2720   REM Otherwise its end of file
 2730   PRINT:PRINT"End of data reached ... Enter new file pointer in range 0 to ";file_length%;" otherwise press return to exit "
 2740   INPUT reply$
 2750   IF reply$ = "" THEN CLOSE#0: PROCnormal_format:BYE
 2760   PTR#f1  = VAL(reply$)
 2770   PRINT
 2780   RETURN
 2790   REM -------
 2800   REM ---- END OF CODE -----
 2810   
        
